unit SortColors0;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
var
  colors : array[1..64] of TColor;
  index  : array[1..64] of integer;

procedure genRandomColor(len :integer);
var
  k : integer;
  r,g,b : byte;
begin
  for k:=1 to len do
     begin
       r := Random(256);
       g := Random(256);
       b := Random(256);
       colors[k] := TColor (RGB(r,g,b));
     end;
end;

procedure drawColor1D(canvas :TCanvas; x0, y0, len :integer; sorted :boolean = false);
var
  k           : integer;
  x, y, dx, dy : byte;
begin
  dx := 12; dy:= 12;
  y := 10;
  for x:=1 to len do
     begin
       if ( sorted ) then
         canvas.Brush.Color := colors[index[x]]
       else canvas.Brush.Color := colors[x];
       canvas.Rectangle(x0+x*dx, y0+y, x0+(x+1)*dx-2, y0+y+dy);
     end;
end;

procedure drawColor2D(canvas :TCanvas; x0, y0, rows, cols :integer; sorted :boolean=false);
var
  k           : integer;
  x, y, dx, dy : byte;
begin
  dx := 20; dy:= 20;
  y := 10;
  for y:=1 to rows do
     begin
       for x:=1 to cols do
          begin
            if ( sorted ) then
              canvas.Brush.Color := colors[index[(y-1)*8+x]]
            else
              canvas.Brush.Color := colors[(y-1)*8+x];
            canvas.Rectangle(x0+x*dx, y0+y*dy, x0+(x+1)*dx-3, y0+(y+1)*dy-2);
          end;
     end;
end;
procedure sortColors;
var
   y, x, k :integer;
   r, g, b : Byte;
   sqr : array[1..64] of integer;
begin
  for k:=1 to 64 do
     begin
       r := GetRValue(colors[k]);
       g := GetGValue(colors[k]);
       b := GetBValue(colors[k]);
       sqr[k] := r*r + g*g + b*b;
       index[k] := k;
     end;
  for y:=1 to 64-1 do
     for x:=y+1 to 64 do
        begin
          if ( sqr[index[y]]>sqr[index[x]] ) then
            begin
              k        := index[y];
              index[y] := index[x];
              index[x] := k;
            end;
        end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
   len : integer;
begin
  len := 64;

  genRandomColor(len);

  drawColor1D(Canvas, 0,   0, len);
  drawColor2D(Canvas, 30, 60, 8, 8);

  sortColors;
  
  drawColor1D(Canvas, 0, 30, len, true);
  drawColor2D(Canvas, 20*8 + 50, 60, 8, 8, true);
end;

end.
